"""$URL: svn+ssh://svn/repos/trunk/dulcinea/lib/interaction.py $
$Id: interaction.py 26450 2005-03-31 22:34:06Z rmasse $
"""

from dulcinea.history import History

class Interactable:

    """Storage for a set of interaction events on an object of interest

    Instance attributes:
      interactions : History
        the interaction history with this interactible object
    """

    interactions_is = History

    EMAIL = 'email'
    MAIL = 'mail'
    PHONE = 'phone'
    FAX = 'fax'
    OTHER = 'other'

    INTERACTION_CODES = (EMAIL, MAIL, PHONE, FAX, OTHER)


    def __init__(self):
        self.interactions = History()

    def get_interaction_history(self):
        return self.interactions

    def get_interaction_codes(self):
        return self.INTERACTION_CODES

    def record_interaction(self, user, code, comment):
        self.interactions.add_event(user, code, comment)


