#!/www/python/bin/python
"""
$URL: svn+ssh://svn/repos/trunk/dulcinea/lib/test/utest_links.py $
$Id: utest_links.py 26532 2005-04-08 19:50:19Z rmasse $
"""

from sancho.utest import UTest

# dulcinea.links requires dulcinea.local.
# This provides a replacement for purposes of this test.
import dulcinea
class TestLocal:
    SITE = 'Test'
dulcinea.local = TestLocal

from dulcinea.links import LinkItem, LinkFolder, sort_reverse_by_date, \
     sort_by_title
from dulcinea.contact import Contact


class LinksTest (UTest):

    class AdminContact(Contact):

        def is_admin(self):
            return True

    def check_link(self):
        self.link = LinkItem()
        self.link.set_link_url('http://www.mems-exchange.org')
        self.link.get_link_url()
        self.link.get_user()
        self.link.set_text('hi')
        assert self.link.get_text() == 'hi'
        self.link.set_email('hi')
        assert self.link.get_email() == 'hi'
        self.link.as_html()
        self.link.as_html(full=1)
        self.link.as_html(action_links='action')
        self.link.as_text()
        self.link.as_rss('www.example.com')
        self.link.as_email()
        assert self.link.is_approved() == False
        self.link.set_approved(True)
        assert self.link.is_approved() == True
        self.link.get_allowed_mime_types()
        self.link.get_allowed_mime_types(
            user=self.AdminContact('superuser'))
        assert self.link.get_local_url() == '/links/None/'
        self.link2 = LinkItem()
        [self.link, self.link2].sort(sort_reverse_by_date)
        [self.link, self.link2].sort(sort_by_title)

    def check_link_folder(self):
        self.link_db = LinkFolder()
        self.link_db.get_category('foo')
        self.link_db.links_with_category('foo')


if __name__ == "__main__":
    LinksTest()
